<template>
    <div :class="{ fullscreen: isStreamingSecondaryMedia }">
        <video ref="primaryVideo" class="primaryVideo" :media-stream.camel="primaryMediaStream" :muted="muted" autoplay playsinline></video>
        <video ref="secondaryVideo" class="secondaryVideo" :media-stream.camel="secondaryMediaStream" :muted="muted" v-show="isStreamingSecondaryMedia" autoplay playsinline></video>
        <statistics :statistics="participant.statistics" :visible="statisticsVisible"/>
        <div class="controls">
            <div class="max-resolution" @click="onMaxResolutionChange">{{ maxResolutions[maxResolutionIndex] }}</div>
            <button class="button speaker" :class="{ on: !muted  }" @click="muted = !muted "/>
            <name class="name" :value="participant.name" @change="changeName"/>
        </div>
    </div>
</template>

<script setup>

    import { ref, computed, onMounted, onBeforeUnmount } from "vue";

    import Statistics from "./Statistics.vue";
    import Name from "./Name.vue";

    const props = defineProps({
        participant: Object,
        statisticsVisible: Boolean,
    });

    const primaryVideo = ref(null);
    const secondaryVideo = ref(null);

    const emit = defineEmits(["change_name"]);

    const isStreamingSecondaryMedia = computed(() => {
        return props.participant.secondaryMediaStream != null;
    });

    const primaryMediaStream = computed(() => {
        return props.participant.primaryMediaStream;
    });

    const secondaryMediaStream = computed(() => {
        return props.participant.secondaryMediaStream;
    });

    const changeName = (name) => {
        emit("change_name", name);
    };

    let maxResolutions = [ "auto", "720p", "360p", "180p" ];

    let maxResolutionIndex = ref(0);

    const onMaxResolutionChange = () => {
        maxResolutionIndex.value = (maxResolutionIndex.value + 1) % maxResolutions.length;
        updateMaxVideoFrameArea();
    }

    let primaryVideoWidth = Number.POSITIVE_INFINITY;
    let primaryVideoHeight = Number.POSITIVE_INFINITY;

    const updateMaxVideoFrameArea = () => {
        let frameArea = Number.POSITIVE_INFINITY;
        if (maxResolutions[maxResolutionIndex.value] === "auto") {
            if (primaryVideoWidth < 1280 && primaryVideoHeight < 720) {
                frameArea = 640 * 360;
            }
            if (primaryVideoWidth < 640 && primaryVideoHeight < 360) {
                frameArea = 320 * 180;
            }
        } else {
            frameArea = new Map([[ "720p", 1280 * 720 ], [ "360p", 640 * 360 ], [ "180p", 320 * 180 ]]).get(maxResolutions[maxResolutionIndex.value]);
        }
        if (primaryVideo.value.mediaStream != null) {
            primaryVideo.value.mediaStream.setMaxVideoFrameArea(frameArea);
        }
    }

    let muted = ref(true);

    let resizeObserver = null;

    onMounted(() => {
        let AudioContext = window.AudioContext || window.webkitAudioContext || Object;
        let audioContext = new AudioContext();
        audioContext.onstatechange = () => {
            if (audioContext.state === "running") {
                muted.value = false;
                audioContext.close();
            }
        }
        resizeObserver = new ResizeObserver((entries) => {
            primaryVideoWidth = entries[0].contentRect.width;
            primaryVideoHeight = entries[0].contentRect.height;
            updateMaxVideoFrameArea();
        });
        resizeObserver.observe(primaryVideo.value);
    });

    onBeforeUnmount(() => {
        if (resizeObserver != null) {
            resizeObserver.unobserve(primaryVideo.value);
            resizeObserver = null;
        }
        primaryVideo.value.mediaStream = null;
        secondaryVideo.value.mediaStream = null;
    });

</script>

<style scoped>

    .fullscreen {
        position: absolute !important;
        width: 100% !important;
        height: 100% !important;
        z-index: 1;
    }

    .primaryVideo {
        position: absolute;
        width: 100%;
        height: 100%;
        object-fit: cover;
        transform: scaleX(-1);
    }

    .secondaryVideo {
        position: absolute;
        width: 100%;
        height: 100%;
        object-fit: cover;
    }

    .controls {
        position: absolute;
        bottom: 5px;
        left: 5px;
        padding: 5px 10px;
        font-size: 1em;
        background: #212121;
        display: flex;
        flex-direction: row;
        align-items: center;
    }

    .max-resolution {
        display: flex;
        font-family: monospace;
        margin-right: 5px;
    }

    .button {
        display: flex;
        width: 1.5em;
        height: 1.5em;
        border: none;
        padding: 0;
        line-height: normal;
        text-decoration: none;
        -webkit-mask-size: cover;
        mask-size: cover;
        cursor: pointer;
        margin-right: 5px;
    }

    .button.speaker {
        background-color: #ffffff;
        -webkit-mask-image: url("../assets/speaker_off.svg");
        mask-image: url("../assets/speaker_off.svg");
    }

    .button.speaker.on {
        background-color: #4caf50;
        -webkit-mask-image: url("../assets/speaker_on.svg");
        mask-image: url("../assets/speaker_on.svg");
    }

</style>